; Source created with Parsic Version 3.x

; at              : 12.09.2010 17:06:25


; Project File    : D:\Apps\parsic\Examples\RS232\SEND.PIC

; Project Version : 1.0.15

; Created         : 10.04.2002 18:26:00

; Last change     : 08.12.2003 20:53:00

	PROCESSOR 16F876

	INCLUDE P16F876.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC & _LVP_OFF & _CPD_OFF & _DEBUG_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

UD1_FD	= 32	; located in Bank 0
S2	= 33	; located in Bank 0
UA1RSFLAG	= 34	; located in Bank 0
ADR	= 35	; located in Bank 0
DATEN1	= 36	; located in Bank 0
DATEN2	= 37	; located in Bank 0
MF1	= 38	; located in Bank 0
MF1_HI	= 39	; located in Bank 0
S0	= 40	; located in Bank 0
MF2	= 41	; located in Bank 0
MF2_HI	= 42	; located in Bank 0
S1	= 43	; located in Bank 0
OS1_FD	= 44	; located in Bank 0
UA1OUTBUF	= 45	; located in Bank 0
UA1OUTBUF1	= 46	; located in Bank 0
UA1OUTBUF2	= 47	; located in Bank 0
UA1OUTBUF3	= 48	; located in Bank 0
UA1OUTBUF4	= 49	; located in Bank 0
RAM	= 50	; located in Bank 0
SYS_WSAV	= 115	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 116	; located in Bank 0, 1, 2, 3
SYS_PSAV	= 117	; located in Bank 0, 1, 2, 3
SYS_TMP1	= 118	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	MOVLW HIGH SYS_INIT	; set page
	MOVWF PCLATH
	GOTO SYS_INIT

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV
	MOVFW PCLATH
	MOVWF SYS_PSAV
	CLRF PCLATH

;***************************************************
; UART -> UA1
;***************************************************


;---------------------------------------------------------

UA1CHKTX
	BTFSS PIR1,TXIF	; send byte ?
	GOTO UA1ENDINT	; no

	BSF PORTC,5	; set dir
	MOVFW UA1OUTBUF+1	; all transmitted ? 
	BTFSC STATUS,ZERO
	GOTO UA1TXINT1

	ERRORLEVEL -312
	BANKISEL UA1OUTBUF	; FILE INDIREKT
	ERRORLEVEL +312

	MOVFW UA1OUTBUF	; pointer
	INCF UA1OUTBUF,F	; pointer+1
	MOVWF FSR
	MOVFW INDF	; data
	MOVWF TXREG	; Transmit Register

	DECF UA1OUTBUF+1,F	; length-1
	GOTO EXITINT	; that's all

UA1TXINT1
	BSF STATUS,RP0	; Bank 1
	BCF STATUS,RP1	; Bank 1
	BTFSS TXSTA,TRMT	; last byte transmitted ?
	GOTO EXITINT	; no

	BCF TXSTA,TXEN	; transmitter off
	BCF STATUS,RP0	; Bank 0
	BCF PORTC,5	; set dir

	BSF UA1RSFLAG,2	; ready
	GOTO EXITINT

UA1ENDINT
	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF2,F
	GOTO SYS_INT_LABEL_1
	INCF MF2_HI,F

SYS_INT_LABEL_1

EXITINT
	MOVFW SYS_PSAV
	MOVWF PCLATH

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Set output before direction

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW B'01000000'
	MOVWF PORTC

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 6	; all Digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11111111'
	MOVWF TRISB

	MOVLW B'10011111'
	MOVWF TRISC

; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 16
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'70'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3
	MOVLW 144
	MOVWF FSR
CR4
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR4


;*****************************************
; initalisize UA1
;*****************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'10010000'	; serial enable,8-bit,continous-enable
	MOVWF RCSTA

	BSF STATUS,RP0	; Bank 1
	MOVLW 207
	MOVWF SPBRG	; BAUDRATE GENERATOR
	MOVLW B'00000100'	; 8-BIt,TRANSMIT DISABLED,ASYNCHRON,BRGH=1=HIGH SPEED
	MOVWF TXSTA
	BSF PIE1,TXIE	; enable INTERRUPT for transmit

	BSF INTCON,PEIE	; PERIPHERIE INT ENABLE

	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTB,0	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S2,0
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,0	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 0
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 78
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S2,0
LABEL_MF1_EXIT

;***************************************************
; Verteiler -> BV1
;***************************************************

	MOVLW 0 
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,0	; IN0
	IORLW 1
	MOVWF S0	; OUT

;***************************************************
; Multiplexer -> MX1
;***************************************************

	CLRF SYS_TMP1
	MOVFW S0
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL1

	MOVFW ADR
	MOVWF ADR
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S0
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL2

	MOVLW 14
	MOVWF ADR
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL2

LABEL_MX1_END

;***************************************************
; Multiplexer -> MX2
;***************************************************

	CLRF SYS_TMP1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S0
	BTFSS STATUS,ZERO
	GOTO LABEL_MX2_CHECKCONTROL1

	MOVFW DATEN1
	MOVWF DATEN1
	GOTO LABEL_MX2_END

LABEL_MX2_CHECKCONTROL1
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S0
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX2_CHECKCONTROL2

	MOVLW 100
	MOVWF DATEN1
	GOTO LABEL_MX2_END

LABEL_MX2_CHECKCONTROL2

LABEL_MX2_END

;***************************************************
; Multiplexer -> MX3
;***************************************************

	CLRF SYS_TMP1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S0
	BTFSS STATUS,ZERO
	GOTO LABEL_MX3_CHECKCONTROL1

	MOVFW DATEN2
	MOVWF DATEN2
	GOTO LABEL_MX3_END

LABEL_MX3_CHECKCONTROL1
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S0
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX3_CHECKCONTROL2

	MOVLW 200
	MOVWF DATEN2
	GOTO LABEL_MX3_END

LABEL_MX3_CHECKCONTROL2

LABEL_MX3_END

;***************************************************
; Anzug-Verzgerung -> MF2
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTB,1	; Eingang auf High ?
	GOTO LABEL_MF2_CHKTIME	; Ja

; RESET

	CLRF MF2
	CLRF MF2_HI
	BCF S2,1
	GOTO LABEL_MF2_EXIT	; raus

LABEL_MF2_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,1	; Ausgang schon auf High ?
	GOTO LABEL_MF2_EXIT	; Ja

	MOVLW 0
	SUBWF MF2_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	MOVLW 78
	SUBWF MF2,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	BSF S2,1
LABEL_MF2_EXIT

;***************************************************
; Verteiler -> BV2
;***************************************************

	MOVLW 0 
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,1	; IN0
	IORLW 1
	MOVWF S1	; OUT

;***************************************************
; Multiplexer -> MX4
;***************************************************

	CLRF SYS_TMP1
	MOVFW S1
	BTFSS STATUS,ZERO
	GOTO LABEL_MX4_CHECKCONTROL1

	MOVFW ADR
	MOVWF ADR
	GOTO LABEL_MX4_END

LABEL_MX4_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX4_CHECKCONTROL2

	MOVLW 20
	MOVWF ADR
	GOTO LABEL_MX4_END

LABEL_MX4_CHECKCONTROL2

LABEL_MX4_END

;***************************************************
; Multiplexer -> MX5
;***************************************************

	CLRF SYS_TMP1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S1
	BTFSS STATUS,ZERO
	GOTO LABEL_MX5_CHECKCONTROL1

	MOVFW DATEN1
	MOVWF DATEN1
	GOTO LABEL_MX5_END

LABEL_MX5_CHECKCONTROL1
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX5_CHECKCONTROL2

	MOVLW 15
	MOVWF DATEN1
	GOTO LABEL_MX5_END

LABEL_MX5_CHECKCONTROL2

LABEL_MX5_END

;***************************************************
; Multiplexer -> MX6
;***************************************************

	CLRF SYS_TMP1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S1
	BTFSS STATUS,ZERO
	GOTO LABEL_MX6_CHECKCONTROL1

	MOVFW DATEN2
	MOVWF DATEN2
	GOTO LABEL_MX6_END

LABEL_MX6_CHECKCONTROL1
	INCF SYS_TMP1,F
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW S1
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX6_CHECKCONTROL2

	MOVLW 2
	MOVWF DATEN2
	GOTO LABEL_MX6_END

LABEL_MX6_CHECKCONTROL2

LABEL_MX6_END

;***************************************************
; UDATA -> UD1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,2	; active
	GOTO LABEL_UD1_1	; yes

; test positive edge

	BTFSS S2,3
	GOTO LABEL_UD1_SETFD
	BTFSC UD1_FD,0
	GOTO LABEL_UD1_SETFD
	BSF UD1_FD,0

	BCF UA1RSFLAG,2		; set not ready
	BSF S2,2	; active

	MOVLW LOW UA1OUTBUF+2	; set pointer (ADRESS)
	MOVWF UA1OUTBUF
	MOVLW 3	; 3 bytes
	MOVWF UA1OUTBUF+1
	BCF INTCON,GIE	; disable interrupts
	BTFSC INTCON,GIE	; disabled ?
	GOTO $-2	; no
	MOVFW ADR
	MOVWF UA1OUTBUF+2
	MOVFW DATEN1
	MOVWF UA1OUTBUF+3
	MOVFW DATEN2
	MOVWF UA1OUTBUF+4
	BSF STATUS,RP0	; Bank 1
	BSF TXSTA,TXEN
	BSF INTCON,GIE	; enable interrupts
LABEL_UD1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS UA1RSFLAG,2	; transmit ready ?
	GOTO LABEL_UD1_2	; no
	BCF S2,2	; not active

LABEL_UD1_2

LABEL_UD1_SETFD

; test negative edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,3
	GOTO LABEL_UD1_EXIT
	BCF UD1_FD,0

LABEL_UD1_EXIT

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSC S2,4
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S2,3
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,3
	BTFSS S2,4
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; ODER - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,0
	GOTO LABEL_LG1_TRUE
LABEL_LG1_2
	BTFSC S2,1
	GOTO LABEL_LG1_TRUE

LABEL_LG1_FALSE
	BCF S2,4
	GOTO LABEL_LG1_ENDE
LABEL_LG1_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S2,4
LABEL_LG1_ENDE
;****************************************

	GOTO MAIN


	END

